/*
** USEFUL MACROS FOR GENERAL USE
**
** Library name:                 no libraries necessary
** This header file name:        auxmacr.h
** Other necessary header files: none
*/

#if !defined(AUXMACR_INCLUDED)
  #define AUXMACR_INCLUDED

#if !defined(BYTE_DEFINED)
  typedef unsigned char byte;
  #define BYTE_DEFINED
#endif

#if !defined(Delete)
  /*Frees allocated memory block using the safe method*/
  #define Delete(p) if ((p)!=NULL) { free(p); p=NULL; }
#endif

#define min(x,y)  ( ((x) < (y)) ? (x) : (y) )
#define max(x,y)  ( ((x) > (y)) ? (x) : (y) )

/* qround() is quicker but can be used only for nonnegative arguments */
#define  round(x)   ( (int)    (floor((x) + 0.5)) )
#define qround(x)   ( (int)    (      (x) + 0.5 ) )
/* ulround() can be used only for nonnegative arguments */
#define ulround(x)  ( (unsigned long)((x) + 0.5 ) )

/* sign of x; x: (arbitrary_type), result: (int)  */
#define sgn(x)  ( ((x) >= 0) ? (1) : (-1) )


#endif /* !defined(AUXMACR_INCLUDED) */
