
#include "pic.h"



int CopyWin2Pic(Tpic *Pinppic,const Twin *Pwin,Tpic *Poutpic) {
  register int brh,x,y;
  Tclr clr;

  if (!IsPicOK(Pinppic) || !IsWinInPic(Pwin,Pinppic))
    return BAD_DATA;

  FreePic(Poutpic);
  if (AllocPic(Poutpic,_mod(Pinppic),Pwin->Zx,Pwin->Zy) != OK)
    return NO_MEMORY;

  switch (_mod(Pinppic)) {
  case GREpic:
    for (y = 0; y < Pwin->Zy; y++)
    for (x = 0; x < Pwin->Zx; x++) {
      brh = GRE(Pinppic,x+Pwin->Mx,y+Pwin->My);
      SetGRE(Poutpic,x,y,brh);
    }
    break;
  case BINpic:
    for (y = 0; y < Pwin->Zy; y++)
    for (x = 0; x < Pwin->Zx; x++) {
      brh = BIN(Pinppic,x+Pwin->Mx,y+Pwin->My);
      SetBIN(Poutpic,x,y,brh);
    }
    break;
  case BIT2pic:
    for (y = 0; y < Pwin->Zy; y++)
    for (x = 0; x < Pwin->Zx; x++) {
      brh = BIT2(Pinppic,x+Pwin->Mx,y+Pwin->My);
      SetBIT2(Poutpic,x,y,brh);
    }
    break;
  case BIT4pic:
    for (y = 0; y < Pwin->Zy; y++)
    for (x = 0; x < Pwin->Zx; x++) {
      brh = BIT4(Pinppic,x+Pwin->Mx,y+Pwin->My);
      SetBIT4(Poutpic,x,y,brh);
    }
    break;
  case CLRpic:
    for (y = 0; y < Pwin->Zy; y++)
    for (x = 0; x < Pwin->Zx; x++) {
      GetCLR(Pinppic,x+Pwin->Mx,y+Pwin->My,clr);
      SetCLR(Poutpic,x,y,clr);
    }
    break;
  default:
    return(BAD_DATA);
  }

  return OK;
} /* CopyWin2Pic */



int Tpic2Twin(const Tpic *Pinppic,Twin *Poutwin) {
  if(!Pinppic || !Poutwin) return BAD_DATA;

  Poutwin->Mx=Poutwin->My=0;
  Poutwin->Zx=Pinppic->Zx;
  Poutwin->Zy=Pinppic->Zy;
  return OK;
} /* Tpic2Twin */
