
#include "pic.h"



int ZeroPic(Tpic *Ppic) {

  if (!IsPicOK(Ppic))
    return BAD_DATA;

  memset(_PpixA(Ppic),(char)0,Ppic->Zpic);

  return OK;
} /* ZeroPic */



int SetAllPic(Tpic *Ppic,Tbrh *Pval) {
/* zapisywanie obrazu ta sama wartoscia */
  register int x,y,b;
  Tclr clrpix;
  Tbrh brh=0,bin,bit4,bit2;

  switch (_mod(Ppic)) {
  case GREpic:
    brh = *Pval;
    break;
  case BINpic:
    bin = (*Pval)?(1):(0);
    for (b = 0; b < 8; b++)
      setBIT1picBYT(brh,b,bin);
    break;
  case BIT2pic:
    bit2 = (*Pval) & 0x03;
    for (b = 0; b < 8; b+=2)
      setBIT2picBYT(brh,b,bit2);
    break;
  case BIT4pic:
    bit4 = (*Pval) & 0x0F;
    for (b = 0; b < 8; b+=4)
      setBIT2picBYT(brh,b,bit4);
    break;
  case CLRpic:
    for (b = 0; b < 3; b++)
      clrpix[b] = Pval[b];
    break;
  default:
    return(BAD_DATA);
  }

  if (_mod(Ppic) != CLRpic)
    memset(_PpixA(Ppic),brh,Ppic->Zpic);
  else
    for (y = 0; y < _Zy(Ppic); y++)
    for (x = 0; x < _Zx(Ppic); x++)
      SetCLR(Ppic,x,y,clrpix);

  return(OK);

} /* SetAllPic */



int SetAllWin(Tpic *Ppic,const void *parPwin,Tbrh *Pval) {
  Twin *Pwin;

  /* volume modes not supported now */
  if ((_mod(Ppic) == BINpicV) || (_mod(Ppic) == GREpicV))
    return(BAD_DATA);
  Pwin = (Twin*)parPwin;

  switch (_mod(Ppic)) {
  case BINpic:
    SetWinBIN(Ppic,Pwin,*Pval); break;
  case BIT2pic:
    SetWinBIT2(Ppic,Pwin,*Pval); break;
  case BIT4pic:
    SetWinBIT4(Ppic,Pwin,*Pval); break;
  case GREpic:
    SetWinGRE(Ppic,Pwin,*Pval); break;
  case CLRpic:
    SetWinCLR(Ppic,Pwin,Pval); break;
  default:
    return(BAD_DATA);
  }

  return(OK);

} /* SetAllWin */



void SetWinBIN(Tpic *Ppic,const Twin *Pwin,int bin) {

  register int x,y;

  bin = (bin)?(1):(0);

  for (y=Pwin->My; y<=_Xy(Pwin); y++)
  for (x=Pwin->Mx; x<=_Xx(Pwin); x++)
    SetBIN(Ppic,x,y,bin);

} /* SetWinBIN */



void SetWinBIT2(Tpic *Ppic,const Twin *Pwin,int bit2) {

  register int x,y;

  bit2 &= 0x03;

  for (y=Pwin->My; y<=_Xy(Pwin); y++)
  for (x=Pwin->Mx; x<=_Xx(Pwin); x++)
    SetBIT2(Ppic,x,y,bit2);

} /* SetWinBIT2 */



void SetWinBIT4(Tpic *Ppic,const Twin *Pwin,int bit4) {

  register int x,y;

  bit4 &= 0x0F;

  for (y=Pwin->My; y<=_Xy(Pwin); y++)
  for (x=Pwin->Mx; x<=_Xx(Pwin); x++)
    SetBIT4(Ppic,y,x,bit4);

} /* SetWinBIT4 */



void SetWinGRE(Tpic *Ppic,const Twin *Pwin,int bin) {

  register int x,y;

  for (y=Pwin->My; y<=_Xy(Pwin); y++)
  for (x=Pwin->Mx; x<=_Xx(Pwin); x++)
    SetGRE(Ppic,x,y,bin);

} /* SetWinGRE */



void SetWinCLR(Tpic *Ppic,const Twin *Pwin,Tclr clr) {

  register int x,y;

  for (y=Pwin->My; y<=_Xy(Pwin); y++)
  for (x=Pwin->Mx; x<=_Xx(Pwin); x++)
    SetCLR(Ppic,x,y,clr);

} /* SetWinCLR */
