
#undef TST

#include <math.h>
#include "auxmacr.h"
#include "pic.h"



void FindShares(Tshr Ishr[],int MIinp,int XIinp,int MIout,int XIout,int mod) {
/* udzialy w kierunku I */
  double Q,d_Ista,d_Iend,d_shrsta,d_shrend;
  int    I,sumshr;

  Q = (double)(XIinp-MIinp+1) / (XIout-MIout+1);
  /* suma ulamkowych udzialow w 1 pikslu - do wyrownowazania udzialow */
  sumshr = (int)(Find1Share(MIout,XIout,MIinp,XIinp) % 256L);
  for (I=0; I<=(XIout-MIout); I++) {
    if (mod == QUICK) {
      /* udzialy niewazne */
      Ishr[I].Iend = -1;
      Ishr[I].Ista = (int)floor(MIinp + Q*(I+0.5));
      Ishr[I].shrsta = Ishr[I].shrend = (byte)255;
      continue;  /* for (I) */
    } /* else: (mod == NORM) */
    d_Ista = MIinp + Q*I;
    d_Iend = MIinp + Q*(I+1);
    Ishr[I].Ista = (int)floor(d_Ista);
    Ishr[I].Iend = (int)floor(d_Iend);
    if (Ishr[I].Ista == Ishr[I].Iend) {
      /* tylko 1 pixel; udzialy niewazne */
      Ishr[I].Iend = -1;
      Ishr[I].shrsta = Ishr[I].shrend = (byte)255;
      continue;  /* for (I) */
    }
    d_shrsta = Ishr[I].Ista + 1.0 - d_Ista;
    if (d_shrsta == 1.0) {
      /* shrxxx nie umozliwia reprezentacji liczby >= 1.0 */
      /* zatem ustawiamy zero w nastepnym pikslu */
      (Ishr[I].Ista)--;
      Ishr[I].shrsta = (byte)0;
    } else
      Ishr[I].shrsta = d2b(d_shrsta);
    d_shrend = d_Iend - Ishr[I].Iend;
    if (d_shrend == 1.0) {
      (Ishr[I].Iend)++;
      Ishr[I].shrend = (byte)0;
    } else
      Ishr[I].shrend = d2b(d_Iend - Ishr[I].Iend);
    /* powtorne badania na 1 piksel */
    if (Ishr[I].Ista == Ishr[I].Iend)
      Ishr[I].Iend = -1;
    else if (
    (Ishr[I].shrsta == (byte)0) &&
    (Ishr[I].shrend == (byte)0) &&
    (Ishr[I].Ista == Ishr[I].Iend-2)
    ) {
      (Ishr[I].Ista)++;
      Ishr[I].Iend = -1;
    } else if (
    (Ishr[I].shrsta == (byte)0) &&
    (Ishr[I].Ista == Ishr[I].Iend-1)
    ) {
      (Ishr[I].Ista)++;
      Ishr[I].Iend = -1;
    } else if (
    (Ishr[I].shrend == (byte)0) &&
    (Ishr[I].Iend == Ishr[I].Ista+1)
    ) {
      /* Ishr[I].Ista pozostaje b/z */
      Ishr[I].Iend = -1;
    } else {
      /* (Ishr[I].Iend != -1) */
      /* rownowazenie sumy udzialow w biezacym pikslu: suma = sumshr;
      staramy sie zmienic ten udzial, ktory jest mniejszy, ale
      nie mozna dopuscic, aby ktorykolwiek udzial stal sie ujemny */
      if (
      (Ishr[I].shrsta > Ishr[I].shrend) ?
        ((sumshr - (int)Ishr[I].shrsta) >= 0) :
       !((sumshr - (int)Ishr[I].shrend) >= 0)
      ) {
        /* shrsta wieksze, lub ponizsza roznica ujemna */
        Ishr[I].shrend = (unsigned char)(sumshr - Ishr[I].shrsta);
      } else {
        /* shrend wieksze, lub powyzsza roznica ujemna */
        Ishr[I].shrsta = (unsigned char)(sumshr - Ishr[I].shrend);
      }
    } /* if (Ishr[I].Iend != -1) */
  } /* for (I) */

  #if defined(TST)
    for (I=0; I<=(XIout-MIout); I++) {
      printf("0 Share %3d: Ista=%3d Iend=%3d  shrsta=%3d shrend=%3d\n",
        I,Ishr[I].Ista,Ishr[I].Iend,Ishr[I].shrsta,Ishr[I].shrend);
      if (I != 0 && I%20 == 0)
        getch();  
    }  
  #endif
  
  /*
  Ista nie moze byc poza <MIinp,XIinp> .
  Iend nie moze byc poza <MIinp,XIinp>, ale moze byc -1 .
  Sytuacja bledu moze powstac, jesli piksel byl z kranca przedzialu, a shrxxx 
  mialo byc == 1, czego reprezentacja w postaci 1 bajtu nie umozliwia; zatem,
  ustawiono zero w nastepnym pikslu, ktory jest poza przedzialem. 
  Zadowalamy sie wtedy przyblizeniem 1 ~= 255/256.
  */
  if (Ishr[0].Ista < MIinp) {
    Ishr[0].Ista = MIinp;
    Ishr[0].shrsta = (byte)255; 
  }  
  if (Ishr[XIout-MIout].Iend > XIinp) {
    Ishr[XIout-MIout].Iend = XIinp;
    Ishr[XIout-MIout].shrend = (byte)255; 
  }  
  #if defined(TST)
    for (I=0; I<=(XIout-MIout); I+= (XIout-MIout)) 
      printf("1 Share %3d: Ista=%3d Iend=%3d  shrsta=%3d shrend=%3d\n",
        I,Ishr[I].Ista,Ishr[I].Iend,Ishr[I].shrsta,Ishr[I].shrend);
    getch();  
  #endif
  
} /* FindShares */



unsigned long int Find1Share(int MIinp,int XIinp,int MIout,int XIout) {
/*
Globalny udzial piksla okna 'out' w pikslu okna 'inp'.
Jezeli udzial jest duzy ( > 1.0), to liczymy go jako
odwrotnosc jego odwrotnosci, zaokraglonej i przeksztalconej na liczbe
calkowita (tez przeksztalcony). Cel jest taki, aby po pomnozeniu przez
przeksztalcona reprezentacje swojej odwrotnosci w wyniku dal on jednosc
(== 256**2), a w reprezentacji liczby malej ( < 1.0) robimy stosunkowo
duzy blad.
*/
  double auxshr = (double)(XIout-MIout+1)/(double)(XIinp-MIinp+1);
  if (auxshr < 1.0)
    return(ulround(256.0 * auxshr));
  else
    return(ulround(256.0*256.0 / ulround(256.0 / auxshr)));

} /* Find1Share */
