
#undef TST

#include <stdio.h>
#include <malloc.h>
#include "auxmacr.h"
#include "pic.h"

#include "skapicmk.h"



int ResizePicMark(const Tpic *Pinppic,Tpic *Poutpic,
              const Twin *Pinpwin,const Twin *Poutwin) {
  int ox,oy,ix,iy,Mx,My,Xx,Xy,err;    
  Tbrh gre;
  Twinscainf sca;

  #if defined(TST)
    printf("inppic: %d,%d; inpwin: %d-%d,%d-%d\n",
      _Zx(Pinppic),_Zy(Pinppic),
      _Mx(Pinpwin),_Xx(Pinpwin),
      _My(Pinpwin),_Xy(Pinpwin));
    printf("outpic: %d,%d; outwin: %d-%d,%d-%d\n",
      _Zx(Poutpic),_Zy(Poutpic),
      _Mx(Poutwin),_Xx(Poutwin),
      _My(Poutwin),_Xy(Poutwin));
  #endif

  if ((err = PrepWinSca(Pinpwin,Poutwin,&sca)) != OK)
    return err;

  for (iy = _My(Pinpwin); iy <= _Xy(Pinpwin); iy++)
  for (ix = _Mx(Pinpwin); ix <= _Xx(Pinpwin); ix++) {

    if ((gre = GRE(Pinppic,ix,iy)) == 0)
      continue;

    /* boundaries of an area which corresponds to the input pixel */
    Mx = Mxsca(ix,sca);
    My = Mysca(iy,sca);
    Xx = Xxsca(ix,sca);
    Xy = Xysca(iy,sca);

    /* neighbouring areas can be non-contiguous; if so, they are extended */

    /* ...but only towards down and right
    while (Mx-1 > Xxsca(ix-1,sca))
      Mx--;
    while (Mx < _Mx(Poutwin))
      Mx++;

    while (My-1 > Xysca(iy-1,sca))
      My--;
    while (My < _My(Poutwin))
      My++;
    */

    while (Xx+1 < Mxsca(ix+1,sca))
      Xx++;
    while (Xx > _Xx(Poutwin))
      Xx--;

    while (Xy+1 < Mysca(iy+1,sca))
      Xy++;
    while (Xy > _Xy(Poutwin))
      Xy--;

    #if defined(TST)
      printf("i: %3d/%-3d,%3d/%-3d; o: %3d-%-3d/%-3d,%3d-%-3d/%-3d\n",
        ix,_Xx(Pinpwin),iy,_Xy(Pinpwin),Mx,Xx,_Xx(Poutwin),My,Xy,_Xy(Poutwin));
      getch();
    #endif

    for (oy = My; oy <= Xy; oy++)
    for (ox = Mx; ox <= Xx; ox++) {
      #if defined(TST)
        if (
        (ox < _Mx(Poutwin) || ox > _Xx(Poutwin)) ||
        (oy < _My(Poutwin) || oy > _Xy(Poutwin))
        ) {
          printf("\n! ERROR in ResizePicMark(): ox=%d(%d-%d) oy=%d(%d-%d)\n",
          ox,_Mx(Poutwin),_Xx(Poutwin),oy,_My(Poutwin),_Xy(Poutwin));
          return ERROR;
        }
      #endif
      SetGRE(Poutpic,ox,oy,gre);
    }
  }

  return OK;              
} /* ResizePicMark */
