
#include "auxmacr.h"
#include "pic.h"



int ProportionWin1As2(Twin *Pw1,const Twin *Pw2) {

  double sca_x,sca_y,sca2x2y;
  int    newI;

  if (!IsWinOK(Pw1) || !IsWinOK(Pw2))
    return(BAD_DATA);

  /* skale: rzedow i kolumn */
  sca_x   = (double)(Pw2->Zx) / (double)(Pw1->Zx);
  sca_y   = (double)(Pw2->Zy) / (double)(Pw1->Zy);
  sca2x2y = (double)(Pw2->Zx) / (double)(Pw2->Zy);
  if (sca_x < sca_y) {
    /* w1 "mniej smukle" niz w2 w kierunku x */
    /* poprawiamy kolumny wedlug sca2x2y i rozmiaru w1 w kierunku rzedow */
    newI = qround((Pw1->Zx) * sca2x2y) + Pw1->Mx - 1;
    if (newI < _Xx(Pw1))
      SetXx(Pw1,newI);
  }
  else {
    /* ... w kierunku y */
    /* poprawiamy rzedy wedlug 1/sca2x2y i rozmiaru w1 w kierunku kolumn */
    newI = qround((Pw1->Zx) / sca2x2y) + Pw1->My - 1;
    if (newI < _Xy(Pw1))
      SetXy(Pw1,newI);
  }

  if (!IsWinOK(Pw1))
    return(ERROR);
  else
    return(OK);

} /* ProportionWin1As2 */
