/*
** DUPLICATING THE PICTURES
**
** Library name:                 pic
** This header file name:        piccpy.h
** Other necessary libraries:    none
** Other necessary header files: this file to be used ONLY as included
**                               from pic.h
*/

#if !defined(PICCPY_INCLUDED)
  #define PICCPY_INCLUDED


/* Making a copy (a duplicate) of *Pinppic in *Poutpic. If *Poutpic not
empty, it is freed. Returns: OK, NO_MEMORY, BAD_DATA.
If NO_MEMORY is returned, *Poutpic is returned freed! */
int CopyPic(Tpic *Pinppic,Tpic *Poutpic);

/* The same as above without copying the block of memory only*/
int CopyPicStruct(Tpic *Pinppic,Tpic *Poutpic);

/* Making a copy (a duplicate) of a window *Pinpwin of *Pinppic in *Poutpic.
If *Poutpic not empty, it is freed. Returns: OK, NO_MEMORY, BAD_DATA.
If NO_MEMORY is returned, *Poutpic is returned freed!
CopyPic() is much faster than CopyWin2Pic()! */
int CopyWin2Pic(Tpic *Pinppic,const Twin *Pinpwin,Tpic *Poutpic);

/* Fills Twin structure with sizes equal to picture Tpic */
int Tpic2Twin(const Tpic *Ppic,Twin *Pwin);

#endif /* !defined(PICCPY_INCLUDED) */
