/*
** ACCESS TO SINGLE PIXELS IN A PICTURE
**
** Library name:                 pic
** This header file name:        picpix.h
** Other necessary libraries:    none
** Other necessary header files: this file to be used ONLY as included
**                               from pic.h
*/

#if !defined(PICPIX_INCLUDED)
  #define PICPIX_INCLUDED

/* get and set brightness or/and colour of pixels */
/* returns 1bit brightness (Tbrh) in pixel (x,y) of picture in mode BINpic */
#define BIN(Ppic,x,y)  getBIT1picBYT(picBYT(Ppic,xBIT1pic(x),y),posBIT1pic(x))
/* returns 1bit brightness (Tbrh) in pixel (x,y,z) of picture in mode BINpicV */
/*#define BINv(Ppic,x,y,z)  ... */
/* sets 1bit brightness (Tbrh)brh in pixel (x,y) of picture in mode BINpic */
#define SetBIN(Ppic,x,y,brh)  \
  setBIT1picBYT(picBYT(Ppic,xBIT1pic(x),y),posBIT1pic(x),brh)
/* sets 1bit brightness (Tbrh)brh in pixel (x,y,z) of picture in mode BINpicV */
/*#define SetBINv(Ppic,x,y,z,brh)  ... */

/* returns 2bit brightness (Tbrh) in pixel (x,y) of picture in mode BIT2pic */
#define BIT2(Ppic,x,y)  getBIT2picBYT(picBYT(Ppic,xBIT2pic(x),y),posBIT2pic(x))
/* sets 2bit brightness (Tbrh)brh in pixel (x,y) of picture in mode BIT2pic */
#define SetBIT2(Ppic,x,y,brh)  \
  setBIT2picBYT(picBYT(Ppic,xBIT2pic(x),y),posBIT2pic(x),brh)

/* returns 4bit brightness (Tbrh) in pixel (x,y) of picture in mode BIT4pic */
#define BIT4(Ppic,x,y)  getBIT4picBYT(picBYT(Ppic,xBIT4pic(x),y),posBIT4pic(x))
/* sets 4bit brightness (Tbrh)brh in pixel (x,y) of picture in mode BIT4pic */
#define SetBIT4(Ppic,x,y,brh)  \
  setBIT4picBYT(picBYT(Ppic,xBIT4pic(x),y),posBIT4pic(x),brh)
/* returns brightness (Tbrh) in pixel (x,y) of picture in mode GREpic */
#define GRE(Ppic,x,y)  picBYT(Ppic,x,y)
/* returns brightness (Tbrh) in pixel (x,y,z) of picture in mode GREpicV */
/*#define GREv(Ppic,x,y,z)  ... */
/* sets brightness (Tbrh)brh in pixel (x,y) of picture in mode GREpic */
#define SetGRE(Ppic,x,y,brh)  picBYT(Ppic,x,y) = (Tbrh)(brh)
/* sets brightness (Tbrh)brh in pixel (x,y,z) of picture in mode GREpicV */
/*#define SetGREv(Ppic,x,y,z,brh)  ... */

/* below, c is one of colour components: Rclr,Gclr,Bclr, while clr is (Tclr) */
/* returns brh (Tbrh) of colour component c in pix (x,y) of pic in mode CLRpic */
#define CLR1(Ppic,x,y,c)  picBYT(Ppic,3*(x)+(c),y)
/* sets (Tbrh)brh of colour component c in pixel (x,y) of pic in mode CLRpic */
#define SetCLR1(Ppic,x,y,c,brh)  CLR1(Ppic,x,y,c) = (Tbrh)(brh)
/* gets colour from pixel (x,y) of picture in mode CLRpic into (Tclr)clr */
#define GetCLR(Ppic,x,y,clr)  memcpy(clr,PpicBYT(Ppic,3*(x),y),3)
/* sets to (Tclr)clr colour in pixel (x,y) of picture in mode CLRpic */
#define SetCLR(Ppic,x,y,clr)  memcpy(PpicBYT(Ppic,3*(x),y),clr,3)


#endif /* !defined(PICPIX_INCLUDED) */
