/*
** SETTING ALL PIXELS OF A PICTURE OR ITS WINDOW TO A SAME VALUE
**
** Library name:                 pic
** This header file name:        picsetal.h
** Other necessary libraries:    none
** Other necessary header files: this file to be used ONLY as included
**                               from pic.h
*/

#if !defined(PICSET_INCLUDED)
  #define PICSET_INCLUDED


/* Zeroing of the entire picture; returns OK or BAD_DATA if pic not allocated */
int ZeroPic(Tpic *Ppic);

/* setting a value in picture or its window; functions return: OK,BAD_DATA */
/* ATTENTION:
   1. For BINpic a value (Tbrh)1 is set if *Pval is nonzero.
   2. For BIT2pic, BIT4pic, 2 or 4 resp. youngest bits of *Pval are taken.
   3. For CLRpic, Pval should point to the first elt of an array type (Tclr).
*/
int SetAllPic(Tpic *Ppic,Tbrh *Pval);
/* below, Pwin should poit to a window of type appropriate to picture mode */
int SetAllWin(Tpic *Ppic,const void *Pwin,Tbrh *Pval);
/* ATTENTION: SetAllPic() is faster than SetAllWin() ! */


#endif /* !defined(PICSET_INCLUDED) */
