/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  Program morf.c                                      *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

/* Module eval.c
   Fitness calculation: T training; U pattern;
	 f0 = 10000 + 3 card(T.U) - card(T) - card(U)
	 f1 = 10000 card(T.U)/card(T+U) 
	    = 10000 card(T.U)/[card(T)+card(U)-card(T.U)]
	 f2 = 10000 max[0,card(T.U)/card(T)-card(T\U)/(10000-card(T))]
                                            {card(T)-card(T.U)}
   Created by T. C. Nguyen on Jul 1, 1997 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pic.h"
#include "pic_io.h"

#define zabraklo_pamieci 6
FILE * in1F;
FILE * in2F;
//FILE * out1F;
FILE * outF;
int tp[10000],up[10000],t[33000],u[33000];
int mtp,mup,mt,mu;
int at,atu,au;
double f0,f1,f2;
void diff(int i,int k,int j,int h,int *bt,int *btu,int *bu)
{
int r,s,ok;
*bt=*btu=*bu=0;
for(r=i;r<k;r++)
{
  ok=0;
  for(s=j;s<h;s++)
   if((t[tp[r]]==u[up[s]])&&(t[tp[r]+1]==u[up[s]+1])){ok=1;break;}
  if (ok==0)(*bt)++;
  else (*btu)++;
}
  *bu=h-j-*btu;
}


int eval(char *NaminF1, char *NaminF2, char * NamoutF)
{
  int i,j;
  int k,h;
  int s;
  char buf[80];
  int bt,btu,bu;
  if ((in1F = fopen(NaminF1,"r")) == NULL )
   {printf("\n  No first input list !"); exit(1); }
  if ((in2F = fopen(NaminF2,"r")) == NULL )
   {printf("\n  No second input list !"); exit(1); }
  if ((outF = fopen(NamoutF,"at")) == NULL )
   {
    printf("\nThe maximum defectiveness output file does not exist. ");
    exit(1);
   }

//-------------reading in1F---------------------------------   
   for (i=0;i<6;i++)fscanf(in1F,"%s",buf);
                  fscanf(in1F,"%[^0-9]",buf);

    k=0;i=0;tp[0]=0;
    while( (h=fscanf(in1F,"%s",buf)) > 0  && i<32000)
     {
      t[i] = atoi(buf); 
//      printf(" %d ",t[i]);

      i++;
      if(i%4==0)
       {
        k++;tp[k]=i;
       }
     }

mt=i;mtp=k;
//  size(tp)=mtp  size(t)=mt
//  sort tp wedlug defektow
for(i=0;i<mtp;i++)
 { 
   for(j=i+1;j<mtp;j++)
    if(t[tp[i]+2]>t[tp[j]+2])
     { 
     s=tp[j];
     tp[j]=tp[i];
     tp[i]=s;

     }
 }

//-------------reading in2F---------------------------------   
for (i=0;i<6;i++)fscanf(in2F,"%s",buf);
                  fscanf(in2F,"%[^0-9]",buf);


    k=0;i=0;up[0]=0;
    while( (fscanf(in2F,"%s",buf)) != 0 && i<32000)
     {
        u[i] = atoi(buf); 
//      printf(" %d ",u[i]);
      i++;
      if(i%4==0)
       {
         k++;up[k]=i;
       }
     }
mu=i;mup=k;
//  size(up)=mup  size(u)=mu
//  sort up wedlug defektow

 for(i=0;i<mup;i++)
 { 
   for(j=i+1;j<mup;j++)
    if(u[up[i]+2]>u[up[j]+2])
     { 
     s=up[j];
     up[j]=up[i];
     up[i]=s;

     }

 }

// Diferent sets
 at=0; atu=0; au=0;
 if(mtp==0)atu=0;
 i=0;k=0;
 while(i<mtp)
 { 
   while(t[tp[k]+2]==t[tp[i]+2])k++;
   j=0;h=0; 
   while(j<mup)
    {
      while(u[up[h]+2]==u[up[j]+2])h++;    
      diff(i,k,j,h,&bt,&btu,&bu);
      at+=bt; atu+=btu; au+=bu;
      printf("at=%d atu=%d au=%d",at,atu,au);
      j=h;  
    }
   i=k;
  } 
  /*
new-->	 f0 = 10000 + 3 card(T.U) - card(T) - card(U)
	 f1 = 10000 card(T.U)/card(T+U) 
	    = 10000 card(T.U)/[card(T)+card(U)-card(T.U)]
	 f2 = 10000 max[0,card(T.U)/card(T)-card(T\U)/(10000-card(T))]
                                            {card(T)-card(T.U)}

old-->	 f0 = 10000 + 30 card(T.U) - card(T) - card(U)
	 f1 = card(T.U)/card(T+U) = card(T.U)/[card(T)+card(U)-card(T.U)]
	 f2 = card(T.U)/max(0.5,card(T\U)) = 
            = card(T.U)/max(0.5,[card(T)-card(T.U)])
         f0=10000+30*atu-mtp-mup;
         f1=1000*atu/(mtp+mup-atu);
         if(mtp==atu)f2=2*atu;
         else f2=atu/(mtp-atu);
*/
//  f0=10000+3*atu-mtp-mup;
  f1=10000*atu/(mtp+mup-atu);
//  f2=(double)atu/mtp-(double)(mtp-atu)/(10000-mtp);
//  if (f2>0)f2*=10000;
//  else f2=0;

  fprintf(outF,"%e\n",f1);
  fclose(outF);




  return OK;
} /* END of segm */



