/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  Program morf.c                                      *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <pic.h>
#include <pic_io.h>
#include "morf.h"

int kk;
int UR, UC, ZX, ZY;
int UR1, UC1, ZX1, ZY1;
int UR_reduced, UC_reduced;
int UR1_reduced, UC1_reduced;
int thr, mf;
int funstr[MAXSIZEFNSTR];
Tpic ypic;
Tpic *Pypic=&ypic;
Tpic ipic[3],opic[3],wpic[3];


char NaminpicF1[80], NaminpicF2[80], NamoutpicF[80];
char NamcontrolF[80], NammesF[80], NamfunstrF[80];
FILE * inpicF1, * inpicF2, * outpicF, * controlF;
FILE * mesF;
FILE * funstrF;

int err;

/* getting the name of the structuring
function and reading the function from the disk */
void StructuringFunctionIn(void);    


void ReadFnstr(TPfnstr fnstr)
/* Procedure reads in the structuring function from the disk */
{
/* int size = 0;*/
 int cntr=0;
/* char line[7];*/
char line[100];
char * k;
int n, n1, n2, n3;

 while((k=fgets(line, 90, funstrF)) != NULL)
  {
   n=sscanf(line," %d %d %d", &n1, &n2, &n3);
   (*fnstr)[cntr++]=n1;
   (*fnstr)[cntr++]=n2;
   (*fnstr)[cntr++]=n3;
}
 fclose(funstrF);

 (*fnstr)[cntr++] = FileEmptyPoint;
 (*fnstr)[cntr++] = FileEmptyPoint;
 (*fnstr)[cntr++] = FileEmptyPoint;

}  /* End of ReadFnstr */

void WriteFnstr(TPfnstr fnstr)
/* Procedure writes the ".tif"-structuring function into the disk */
{
int x,y,x0=0,y0=0,x1=0,y1=0,val;

for (y = 0; y <= ZY1; y++)  {
    for (x = 0; x <= ZX1; x++) if (GRE(Pypic,x,y) != 0)break;
    if(x<=ZX1){y0=y;break;}
  }
for (y = ZY1; y > 0; y--)  {
   for (x = 0; x <= ZX1; x++) if (GRE(Pypic,x,y) != 0)break;
   if(x<=ZX1){y1=y;break;}
  }
for (x = 0; x <= ZX1; x++)
  {
   for (y = 0; y <= ZY1; y++) if (GRE(Pypic,x,y) != 0)break;
   if(y<=ZY1){x0=x;break;}
  }
for (x = ZX1; x >0; x--)
  {
   for (y = 0; y <= ZY1; y++) if (GRE(Pypic,x,y) != 0)break;
   if(y<=ZY1){x1=x;break;}
  }

for (y = y1; y >= y0; y--)
  {
   for (x = x0; x <= x1; x++) if ((val=GRE(Pypic,x,y)) != 0)
   fprintf(funstrF,"%d %d %d\n",x-x0,y1-y,val);
  }
fclose(funstrF);
}  /* End of WriteFnstr */


void main(int argc, char *argv[])
{
  char Namoper[10];
  int opcode;

Tpic grepic1, grepic2, xpic;
Tpic *Pgrepic1=&grepic1;
Tpic *Pgrepic2=&grepic2;
Tpic *Pxpic=&xpic;
char *str1;
char *str2;
char *str3;
div_t x;
int inttest;
register i,j;
setcbrk(1);

if (argc==1) exit(-1);
strcpy(NamcontrolF, argv[1]);
printf("\n%s",NamcontrolF);
if ((controlF=fopen(NamcontrolF,"r"))==NULL)
{printf(" - WRONG CONTROL FILE");
 exit(1);
}

sprintf(NammesF,"morf.res");
 if ( (mesF = fopen(NammesF,"at")) == NULL )
  {
   printf("\nThe information file cannot be opened. ") ;
   exit(-1);
  }

 fprintf(mesF,"\n\n");

 InitPic(Pgrepic1);
 InitPic(Pgrepic2);
 InitPic(Pxpic);
 InitPic(&ipic[0]);
 InitPic(&ipic[1]);
 InitPic(&ipic[2]);
 InitPic(&opic[0]);
 InitPic(&opic[1]);
 InitPic(&opic[2]);
 InitPic(&wpic[0]);
 InitPic(&wpic[1]);
 InitPic(&wpic[2]);

   /* Getting the name of the operation */
XX: fscanf(controlF,"%s",Namoper);
    if (strcmp(Namoper, "DILATION") == 0)
     opcode = DIL;
    else if (strcmp(Namoper, "EROSION") == 0)
     opcode = ERO;
    else if (strcmp(Namoper, "OPENING") == 0)
      opcode = OPEN;
    else if (strcmp(Namoper, "CLOSING") == 0)
     opcode = CLOSE;
    else if (strcmp(Namoper, "MAXIMUM") == 0)
     opcode = MAX;
    else if (strcmp(Namoper, "MINIMUM") == 0)
     opcode = MIN;
    else if (strcmp(Namoper, "MFSUBTRACTION") == 0)
     opcode = SUB;
    else if (strcmp(Namoper, "THRESHOLD") ==0)
     opcode = THRESH;
    else if (strcmp(Namoper, "SAMPLING") == 0)
     opcode = SAMPL;
    else if (strcmp(Namoper, "RECONSTRUCTION") == 0)
     opcode = RECONSTR;
    else if (strcmp(Namoper, "RECGRAY") == 0)
     opcode = RECGRAY;
    else if (strcmp(Namoper, "BLOCKING") == 0)
     opcode = BLOCK;
    else if (strcmp(Namoper, "COMPLEMENT") == 0)
     opcode =  COMPL;
    else if (strcmp(Namoper, "SEGMENTATION") == 0)
     opcode =  SEGM;
    else if (strcmp(Namoper, "EVALUATION") == 0)
     opcode =  EVAL;
    else if (strcmp(Namoper, "ID") == 0)
     opcode =  ID;
     else
     {
      if (strcmp(Namoper, "END") ==0) printf("\n%s",Namoper);
      else printf("\n%s operation does not exist",Namoper);
      fclose(mesF);
      fclose(controlF);
      exit(0);
     }

  switch(opcode)
    {

     case DIL:
     printf("\n\nDILATION");
     fprintf(mesF,"DILATION");
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(&ipic[1],str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(&ipic[1]);
     UR=_Zy(&ipic[1]);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     StructuringFunctionIn();
     dilation_c(&ipic[1], Pxpic, (TPfnstr)funstr);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(&opic[1]);
     FreePic(Pxpic);
     break;

     case ERO:
     printf("\n\nEROSION");
     fprintf(mesF,"EROSION");
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(&ipic[1],str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(&ipic[1]);
     UR=_Zy(&ipic[1]);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     StructuringFunctionIn();
     erosion_c(&ipic[1], Pxpic, (TPfnstr)funstr);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(&opic[1]);
     FreePic(Pxpic);
     break;

     case OPEN:
     printf("\n\nOPENING");
     fprintf(mesF, "OPENING");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(&ipic[1],str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(&ipic[1]);
     UR=_Zy(&ipic[1]);
     UC1=UC-1;
     UR1=UR-1;
     AllocPic(&ipic[0],GREpic,UC,UR);
     AllocPic(&ipic[2],GREpic,UC,UR);
     for (i=0;i<UC;i++)
      for(j=0;j<UR;j++)
      {
       SetGRE(&ipic[0],i,j,(Tbrh)0);
       SetGRE(&ipic[2],i,j,(Tbrh)0);
      }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(&opic[0],GREpic,UC,UR);
     AllocPic(&opic[1],GREpic,UC,UR);
     AllocPic(&opic[2],GREpic,UC,UR);
     StructuringFunctionIn();
     f_opening_c(&ipic[0],&opic[0], (TPfnstr)funstr);
     printf("\nSaving the output image");
     WriteTiffShort(str3,&opic[1]);
     FreePic(&opic[0]);
     FreePic(&opic[1]);
     FreePic(&opic[2]);
     break;

     case CLOSE:
     printf("\n\nCLOSING");
     fprintf(mesF, "CLOSING");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(&ipic[1],str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(&ipic[1]);
     UR=_Zy(&ipic[1]);
     UC1=UC-1;
     UR1=UR-1;
     AllocPic(&ipic[0],GREpic,UC,UR);
     AllocPic(&ipic[2],GREpic,UC,UR);
     for (i=0;i<UC;i++)
      for(j=0;j<UR;j++)
      {
       SetGRE(&ipic[0],i,j,(Tbrh)0);
       SetGRE(&ipic[2],i,j,(Tbrh)0);
      }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(&opic[0],GREpic,UC,UR);
     AllocPic(&opic[1],GREpic,UC,UR);
     AllocPic(&opic[2],GREpic,UC,UR);
     StructuringFunctionIn();
     f_closing_c(&ipic[0],&opic[0], (TPfnstr)funstr);
     printf("\nSaving the output image");
     WriteTiffShort(str3,&opic[1]);
     FreePic(&opic[0]);
     FreePic(&opic[1]);
     FreePic(&opic[2]);
     break;

     case MAX:
     printf("\n\nMAXIMUM");
     fprintf(mesF, "MAXIMUM");
     /* Getting the name of the first input image */
     printf("\nType in the name of the first input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the second input image */
     printf("\nType in the name of the second input image: ");
     fscanf(controlF, "%s",NaminpicF2);
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     str2=NaminpicF2;
     if (ReadTiffShort(Pgrepic2,str2)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     maximum(Pgrepic1, Pgrepic2, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case MIN:
     printf("\n\nMINIMUM");
     fprintf(mesF, "MINIMUM");
     /* Getting the name of the first input image */
     printf("\nType in the name of the first input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     ReadTiffShort(Pgrepic1,str1);
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the second input image */
     printf("\nType in the name of the second input image: ");
     fscanf(controlF, "%s",NaminpicF2);
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     str2=NaminpicF2;
     if (ReadTiffShort(Pgrepic2,str2)!=OK) {
      printf("\nError reading the input %s file", NaminpicF2);
      exit(1);
     }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     minimum(Pgrepic1, Pgrepic2, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case SUB:
     printf("\n\nMFSUBTRACTION");
     fprintf(mesF, "MFSUBTRACTION");
     /* Getting the name of the first input image */
     printf("\nType in the name of the first input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the second input image */
     printf("\nType in the name of the second input image: ");
     fscanf(controlF, "%s",NaminpicF2);   
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     str2=NaminpicF2;
     if (ReadTiffShort(Pgrepic2,str2) !=OK) {
      printf("\nError reading the input %s file", NaminpicF2);
      exit(1);
     }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     printf("\nType in the magnification factor: ");
     fscanf(controlF,"%d",&mf);
     if(mf==0)mf=1;// default mf=1
     printf(" MF = %d",mf);
     fprintf(mesF," MF = %d",mf);
     inttest=mfsubtraction(Pgrepic1, Pgrepic2, Pxpic, mf);
     if (inttest==1) {
      printf("\n Incorrect subtraction of images\n");
      fprintf(mesF,"\n      Incorrect subtraction of images\n");
      exit(1);
     }
     if (inttest==2) {
      printf("\n Magnification factor is too high\n");
      fprintf(mesF,"\n      Magnification factor is too high\n");
      exit(1);
     }
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case THRESH:
     printf("\n\nTHRESHOLDING");
     fprintf(mesF,"THRESHOLDING");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     printf("\nType in the threshold value: ");
     fscanf(controlF,"%d",&thr);
     printf("THR = %d",thr);
     fprintf(mesF," THR = %d", thr);
     threshold(Pgrepic1, Pxpic, thr);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case SAMPL:
     printf("\n\nSAMPLING");
     fprintf(mesF,"SAMPLING");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     ReadTiffShort(Pgrepic1,str1);
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;

     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     x=div(UC,reduction);
     UC_reduced=(int) x.quot;
     x=div(UR,reduction);
     UR_reduced=(int) x.quot;
     UC1_reduced=UC_reduced-1;
     UR1_reduced=UR_reduced-1;
     AllocPic(Pxpic,GREpic,UC_reduced,UR_reduced);
     sample(Pgrepic1, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case RECONSTR:
     printf("\n\nRECONSTRUCTION");
     fprintf(mesF,"RECONSTRUCTION");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC_reduced=_Zx(Pgrepic1);
     UR_reduced=_Zy(Pgrepic1);
     UC1_reduced=UC_reduced-1;
     UR1_reduced=UR_reduced-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     UR=2*UR_reduced;
     UC=2*UC_reduced;
     UR1=UR-1;
     UC1=UC-1;
     AllocPic(Pxpic,GREpic,UC,UR);
     recons(Pgrepic1, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case RECGRAY:
     printf("\n\nRECGRAY");
     fprintf(mesF,"RECGRAY");
     /* Getting the name of the first input image */
     printf("\nType in the name of the first input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the second input image */
     printf("\nType in the name of the second input image: ");
     fscanf(controlF, "%s",NaminpicF2);
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     str2=NaminpicF2;
     ReadTiffShort(Pgrepic2,str2);
     if (ReadTiffShort(Pgrepic2,str2)!=OK) {
      printf("\nError reading the input %s file", NaminpicF2);
      exit(1);
     }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     recgray(Pgrepic1, Pgrepic2);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pgrepic2);
//     FreePic(Pxpic);
     break;

     case BLOCK:
     printf("\n\nBLOCKING");
     fprintf(mesF,"BLOCKING");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC_reduced=_Zx(Pgrepic1);
     UR_reduced=_Zy(Pgrepic1);
     UC1_reduced=UC_reduced-1;
     UR1_reduced=UR_reduced-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     UR=2*UR_reduced;
     UC=2*UC_reduced;
     UR1=UR-1;
     UC1=UC-1;
     AllocPic(Pxpic,GREpic,UC,UR);
     block(Pgrepic1, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case COMPL:
     printf("\n\nCOMPLEMENT");
     fprintf(mesF,"COMPLEMENT");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     AllocPic(Pxpic,GREpic,UC,UR);
     complement(Pgrepic1, Pxpic);
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pxpic);
     FreePic(Pxpic);
     break;

     case SEGM:
     printf("\n\nSEGMENTATION");
     fprintf(mesF, "SEGMENTATION");
     /* Getting the name of the first input image */
     printf("\nType in the name of the first input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the second input image */
     printf("\nType in the name of the second input image: ");
     fscanf(controlF, "%s",NaminpicF2);
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     str2=NaminpicF2;
      if (ReadTiffShort(Pgrepic2,str2)!=OK) {
      printf("\nError reading the input %s file", NaminpicF2);
      exit(1);
     }
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
//     AllocPic(Pxpic,GREpic,UC,UR);
     segm(Pgrepic1, Pgrepic2, NamoutpicF);
     printf("\nEnd of SEGM.");
//     WriteTiffShort(str3,Pxpic);
//     FreePic(Pxpic);
     break;

     case EVAL:
     printf("\n\nEVALUATION");
     fprintf(mesF, "EVALUATION");
     /* Getting the name of the first input list */
     printf("\nType in the name of the first input list: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     /* Getting the name of the second input list (patern) */
     printf("\nType in the name of the second input list (patern): ");
     fscanf(controlF, "%s",NaminpicF2);
     printf("%s",NaminpicF2);
     fprintf(mesF," %s",NaminpicF2);
     /* Getting the name of the output value file */
     printf("\nType in the name of the output value file: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
//     str3=NamoutpicF;
//     AllocPic(Pxpic,GREpic,UC,UR);
     eval(NaminpicF1,NaminpicF2,NamoutpicF);
//     printf("\nSaving the output image");
//     WriteTiffShort(str3,Pxpic);
//     FreePic(Pxpic);
     break;
     case ID:
     printf("\n\nID");
     fprintf(mesF, "ID");
     /* Getting the name of the input image */
     printf("\nType in the name of the input image: ");
     fscanf(controlF, "%s",NaminpicF1);
     printf("%s",NaminpicF1);
     fprintf(mesF," %s",NaminpicF1);
     str1=NaminpicF1;
     if (ReadTiffShort(Pgrepic1,str1)!=OK) {
      printf("\nError reading the input %s file", NaminpicF1);
      exit(1);
     }
     UC=_Zx(Pgrepic1);
     UR=_Zy(Pgrepic1);
     UC1=UC-1;
     UR1=UR-1;
     /* Getting the name of the output image */
     printf("\nType in the name of the output image: ");
     fscanf(controlF, "%s",NamoutpicF);
     printf("%s",NamoutpicF);
     fprintf(mesF," %s",NamoutpicF);
     str3=NamoutpicF;
     printf("\nSaving the output image");
     WriteTiffShort(str3,Pgrepic1);
     break;

     default:
     break;
    }
  fprintf(mesF,"\n");
  goto XX;
 
}

void StructuringFunctionIn(void)
{  /* Getting the name of the structuring function */
   char temp[12];
   char *tok,*str;
   printf("\nType in the name of the structuring function: ");
   fscanf(controlF,"%s",NamfunstrF);
   strcpy(temp,NamfunstrF);
   if((tok = strstr(temp,".tif")) != NULL )
   {
     *(tok+1)='s';
     *(tok+2)='\0';
     if ((funstrF = fopen(temp,"r")) == NULL )
     {
      if ((funstrF = fopen(temp,"w")) == NULL )
        {
         printf("\nNo place for Structuring Function. ") ;
         exit(-1);
        }
      str=NamfunstrF;
      if (ReadTiffShort(Pypic,str)!=OK) {
      printf("\nError reading the input %s file", NamfunstrF);
      exit(1);
     }
      ZX=_Zx(Pypic);
      ZY=_Zy(Pypic);
      ZX1=ZX-1;
      ZY1=ZY-1;
      WriteFnstr((TPfnstr)funstr);
      funstrF = fopen(temp,"r");
     }
   }
    else
    {
     printf("%s",NamfunstrF);
     if ((funstrF = fopen(NamfunstrF,"r")) == NULL )
     {
      printf("\n The structuring function does not exist ");
      fprintf(mesF,"\nSTRUCTURING FUNCTION: ");
      fprintf(mesF,"%s Does not exist. End of sequence \n",NamfunstrF);
      exit(-1);
     }
    }
    printf("\nReading the structuring function");
    ReadFnstr((TPfnstr)funstr);
    fprintf(mesF,"\nSTRUCTURING FUNCTION: %s ",NamfunstrF);
    fclose(funstrF);
}
