/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  morf.h                                      *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

/* morf.h
   Updated on Mar 27, 1997 */

#define ROW                 0
#define COLUMN              1
#define VALUE               2

#define DIL                 1
#define ERO                 2
#define OPEN                3
#define CLOSE               4
#define MAX                 5
#define MIN                 6
#define SUB                 7
#define THRESH              8
#define SAMPL               9
#define RECONSTR           10
#define BLOCK              11
#define COMPL              12
#define SEGM               13
#define EVAL               14
#define ID                 15
#define RECGRAY            16

#define reduction           2

#define MAXSIZEFNSTR 10003

#define YES              1
#define NO               0

#define NORMAL           1
#define INVERSE         -1
#define OK               0

#define FileEmptyPoint 255
#define ScrEmptyPoint   -1

#define EMPTY            0
#define FULL             1

extern char NaminpicF1[80], NaminpicF2[80], NamoutpicF[80];
extern FILE *inpicF1, *inpicF2;
extern FILE *outpicF;

extern char NammesF[80];
extern FILE *mesF;

/*extern int UR1;
extern int UC1;*/

extern char NamcontrolF[80];
extern FILE *controlF;
extern int err;
extern char * opis;

typedef int ( *TPfnstr)[MAXSIZEFNSTR];

int  funstr[MAXSIZEFNSTR];

extern int dilation_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int erosion_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int opening_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int closing_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int f_opening_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int f_closing_c(Tpic * picture, Tpic * result, TPfnstr funstr);
extern int mfsubtraction(Tpic * picture1, Tpic * picture2,
	   Tpic * result, int mf); 
extern int maximum(Tpic * picture1, Tpic * picture2, Tpic * result);
extern int minimum(Tpic * picture1, Tpic * picture2, Tpic * result);
extern int threshold(Tpic * picture, Tpic * result, int thr);
extern int sample(Tpic * inpic, Tpic * outpic);
extern int recons(Tpic * inpic, Tpic * outpic);
extern int recgray(Tpic *picture1, Tpic *picture2);
extern int block(Tpic * inpic, Tpic * outpic);
extern int complement(Tpic * inpic, Tpic * outpic);
extern int segm(Tpic * inpic, Tpic * outpic, char *NamoutF);
extern int eval(char * NaminF1, char *NaminF2, char *NamoutF);
extern void ReadFnstr(TPfnstr fnstr);

