/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  Module segm.c                                     *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

/* Module segm.c
   Created on Mar 27, 1997 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pic.h"
#include "pic_io.h"
#include "morf.h"

extern int UR;
extern int UC;
extern int UR1;
extern int UC1;
extern int UR_reduced;
extern int UC_reduced;

#define zabraklo_pamieci 6
#define Defectsmax  1024

FILE * outF;

int segm(Tpic * grepic, Tpic * grepic2, char * NamoutF)
{
  int i,j;
  int v,w,z;
  int k,c;
  int zmax,wmax,r,s;
  int g1[Defectsmax],g2[Defectsmax];
  int ftmp[4];
  
  Tpic  xpic;
  Tpic *Pxpic   = &xpic;
  InitPic(Pxpic);
  FreePic(Pxpic);
  if (AllocPic(Pxpic,GREpic,UC,UR) != OK) exit(1001);

  if ((outF = fopen(NamoutF,"wt")) == NULL )
     {
      printf("\nThe output file does not exist. ");
      exit(1);
     }

  w=1;
  z=0;
  for (i=0;i<=UR1;i++)
    SetGRE(grepic,0,i, (Tbrh) 255);
  for (i=0;i<=UR1;i++)
    SetGRE(grepic,UC1,i,(Tbrh) 255);
  for (j=0;j<=UC1;j++)
    SetGRE(grepic,j,0, (Tbrh) 255);


  for (i=0;i<Defectsmax;i++)
  {
  g1[i]=255;
  g2[i]=255;
  }

  for (i=0;i<=UR1;i++)
   for (j=0;j<=UC1;j++)
    SetGRE(Pxpic,j,i, (Tbrh) 255);

  for (i=1;i<UR1;i++)
   for (j=1;j<UC1;j++)
   {
   if (GRE(grepic,j,i)==(Tbrh) 255) goto E;
   ftmp[0]=(int) GRE(grepic,j-1,i);
   ftmp[1]=(int) GRE(grepic,j-1,i-1);
   ftmp[2]=(int) GRE(grepic,j,i-1);
   ftmp[3]=(int) GRE(grepic,j+1,i-1);
   if (ftmp[0]==255 && ftmp[1]==255 &&
    ftmp[2]==255 && ftmp[3]==255)
     {
      z++;
      if (z==254)  goto FINISH;
      // exit(1);
      SetGRE(Pxpic,j,i, (Tbrh) z);
     }
     else
      {
       k=ftmp[0];
       if (ftmp[1]<k) k=ftmp[1];
       if (ftmp[2]<k) k=ftmp[2];
       if (ftmp[3]<k) k=ftmp[3];
       SetGRE(Pxpic,j,i, (Tbrh) k);
       if (ftmp[0]==ftmp[1] && ftmp[0]==ftmp[2] &&
       ftmp[0]==ftmp[3]) goto E;
       else
       {
	for (c=0;c<=3;c++)
	 {
      if (k!= ftmp[c] && ftmp[c]!=255)
	   {
	    for (v=1;v<=w; v++)
	if (k== g2[v] && ftmp[c]==g1[v]) goto L1;
	    w++;
    if (w==Defectsmax) goto FINISH;
	//exit(1);
        g2[w]=(int) GRE(Pxpic,j,i);
        g1[w]=ftmp[c];
	   }
L1:        ;
	 }
       }
      }
 E:;
    SetGRE(grepic,j,i, (Tbrh) GRE(Pxpic,j,i));
   }

  zmax=z;
  wmax=w;

L2:  v=0;
  for (r=1;r<=wmax;r++)
   for (s=1;s<=wmax;s++)
    if (g1[r]==g2[s] && s>1)
     {
       g2[s]=g2[r];
       zmax--;
       v=1;
     }

  if (v==1) goto L2;

  for (i=1;i<=UR1;i++)
   for (j=1;j<UC1;j++)
    for (r=wmax;r>=1;r--)
     if (GRE(Pxpic,j,i)==(Tbrh) g1[r]) SetGRE(Pxpic,j,i, (Tbrh) g2[r]);

  fprintf(outF,
    "\nRow    Column           Defect No     Defectiveness Measure\n\n");
  for (i=0; i<=UR1; i++)
   for (j=0; j<=UC1; j++)
  {   if (GRE(Pxpic,j,i) != (Tbrh) 255) fprintf(outF,
   "\n%d        %d               %d                  %d",
   i,j, (int) GRE(Pxpic,j,i),(int) GRE(grepic2,j,i));
   }

FINISH:

  fprintf(outF,"\n");
  fclose(outF);
  FreePic(Pxpic);

  return OK;
} /* END of segm */




 

