/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  Program potts.c                                     *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

/* Program potts.cc.
   Created on Jan 15, 1998 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <pic.h>
#include <pic_io.h>
#include <math.h>

#define NEXTLINE "%*[^\n]"

int UR, UC;
int z1,z2,z3;
float ud0sample;
int tmpint;

char NaminpicF1[80], NamoutpicF[80];
char NamcontrolF[80], NammesF[80];
FILE * inpicF1, * outpicF, * controlF;
FILE * mesF;
double alpha[4], beta[4][2];
double t, prob_of_one[4];
double sum_of_probs, cumulative_prob[4];
int struct_el0[5][2];
int struct_el1[3][2];
int i;
int minimum[5];
int count;
int pixel_value;
int err;

int erosion_c0(Tpic * picture, int col, int row);
int erosion_c1(Tpic * picture, int col, int row);
int one_pixel_ero0(Tpic * picture, int pic_col, int pic_row);
int one_pixel_ero1(Tpic * picture, int pic_col, int pic_row);
int count_ones(int size_of_el);
float randomfunction();

int main(int argc, char *argv[])
{
  int pic_col, pic_row;
  int count;
//  double t;

  int * int_ptr0_0;
  int * int_ptr1_0;
  int * ref_int_ptr0_0;
  int * ref_int_ptr1_0;
  
  int * int_ptr0_1;
  int * int_ptr1_1;
  int * ref_int_ptr0_1;
  int * ref_int_ptr1_1;
  
  int * int_ptr0_2;
  int * int_ptr1_2;
  int * ref_int_ptr0_2;
  int * ref_int_ptr1_2;
  
  int * int_ptr0_3;
  int * int_ptr1_3;
  int * ref_int_ptr0_3;
  int * ref_int_ptr1_3;
  
 Tpic grepic1, grepic2, grepic3, grepic4, grepic5, xpic;
 Tpic grepict0, grepict1, grepict2, grepict3;
 Tpic *Pgrepic1=&grepic1;
 Tpic *Pgrepic2=&grepic2;
 Tpic *Pgrepic3=&grepic3;
 Tpic *Pgrepic4=&grepic4;
 Tpic *Pgrepic5=&grepic5;
 Tpic *Pxpic=&xpic;
 Tpic *Pgrepict0=&grepict0;
 Tpic *Pgrepict1=&grepict1;
 Tpic *Pgrepict2=&grepict2;
 Tpic *Pgrepict3=&grepict3;

 char *str1;
 char *str2;
 char *strt0;
 char *strt1;
 char *strt2;
 char *strt3;

 setcbrk(1);

 if (argc==1) exit(-1);
 strcpy(NamcontrolF, argv[1]);
 printf("\n%s",NamcontrolF);
 if ((controlF=fopen(NamcontrolF,"r"))==NULL)
  {printf(" - WRONG CONTROL FILE");
   exit(1);
  }

 sprintf(NammesF,"potts.res");
 if ( (mesF = fopen(NammesF,"at")) == NULL )
 {
  printf("\nThe information file cannot be opened. ") ;
  exit(-1);
 }

 fprintf(mesF,"\n\n");

 struct_el0[0][0]=0;
 struct_el0[0][1]=0;
 struct_el0[1][0]=1;
 struct_el0[1][1]=0;
 struct_el0[2][0]=-1;
 struct_el0[2][1]=0;
 struct_el0[3][0]=0;
 struct_el0[3][1]=1;
 struct_el0[4][0]=0;
 struct_el0[4][1]=-1;

 struct_el1[0][0]=0;
 struct_el1[0][1]=0;
 struct_el1[1][0]=1;
 struct_el1[1][1]=0;
 struct_el1[2][0]=-1;
 struct_el1[2][1]=0;

 InitPic(Pgrepic1);
 InitPic(Pgrepic2);
 InitPic(Pgrepic3);
 InitPic(Pgrepic4);
 InitPic(Pgrepic5);
 InitPic(Pgrepict0);
 InitPic(Pgrepict1);
 InitPic(Pgrepict2);
 InitPic(Pgrepict2);
 InitPic(Pgrepict3);
 InitPic(Pxpic);

 for (i=0; i<4; i++)
  {
   fscanf(controlF, "%lf"NEXTLINE,&alpha[i]);
   printf("\n%f",alpha[i]);
   fscanf(controlF, "%lf"NEXTLINE,&beta[i][0]);
   printf("\n%f",beta[i][0]);
   fscanf(controlF, "%lf"NEXTLINE,&beta[i][1]);
   printf("\n%f",beta[i][1]);
  }

 count=0;
 
XX:
  printf("\nType in the name of the input image: ");
  fscanf(controlF, "%s"NEXTLINE,NaminpicF1);
  printf("%s",NaminpicF1);
  fprintf(mesF," %s",NaminpicF1);
  if (strcmp(NaminpicF1, "FINISH")==0)  
  { 
   fclose(mesF);
   fclose(controlF);
   return 1;
  }
  str1=NaminpicF1;
  ReadTiffShort(Pgrepic1,str1);
  UC=_Zx(Pgrepic1);
  UR=_Zy(Pgrepic1);

  printf("\nType in the name of the output image: ");

  fscanf(controlF, "%s"NEXTLINE,NamoutpicF);
  printf("%s",NamoutpicF);
  fprintf(mesF," %s",NamoutpicF);
  str2=NamoutpicF;
  if (count==0)
  {
  AllocPic(Pxpic,GREpic,UC,UR);
  AllocPic(Pgrepic2,GREpic,UC,UR);
  AllocPic(Pgrepic3,GREpic,UC,UR);
  AllocPic(Pgrepic4,GREpic,UC,UR);
  AllocPic(Pgrepic5,GREpic,UC,UR);
  AllocPic(Pgrepict0,GREpic,UC,UR);
  AllocPic(Pgrepict1,GREpic,UC,UR);
  AllocPic(Pgrepict2,GREpic,UC,UR);
  AllocPic(Pgrepict3,GREpic,UC,UR); 
  count=1;}

  strt0="t0.tif";
  strt1="t1.tif";
  strt2="t2.tif";
  strt3="t3.tif";
  
  printf("\nz1= ");
  fscanf(controlF,"%d"NEXTLINE,&z1);
  printf("%d",z1);

  printf("\nz2= ");
  fscanf(controlF,"%d"NEXTLINE,&z2);
  printf("%d",z2);

  printf("\nz3= ");
  fscanf(controlF,"%d"NEXTLINE,&z3);
  printf("%d",z3); 
 
  for (pic_col=0; pic_col<UC; pic_col++)
   for (pic_row=0; pic_row<UR; pic_row++)
    {
     SetGRE(Pgrepict0,pic_col, pic_row, (Tbrh) 0);
     SetGRE(Pgrepict1,pic_col, pic_row, (Tbrh) 0);
     SetGRE(Pgrepict2,pic_col, pic_row, (Tbrh) 0);
     SetGRE(Pgrepict3,pic_col, pic_row, (Tbrh) 0);
    }

  for (pic_col=0; pic_col<UC; pic_col++)
   for (pic_row=0; pic_row<UR; pic_row++)
    { tmpint=(int) GRE(Pgrepic1,pic_col,pic_row);
      if (tmpint==0) SetGRE(Pgrepict0,pic_col,pic_row,(Tbrh) 255);
      else if (tmpint==85) SetGRE(Pgrepict1,pic_col,pic_row,(Tbrh) 255);
      else if (tmpint==170) SetGRE(Pgrepict2,pic_col,pic_row,(Tbrh) 255);
      else  SetGRE(Pgrepict3,pic_col,pic_row,(Tbrh) 255);
    }
/*
   WriteTiffShort(strt0, Pgrepict0);
   WriteTiffShort(strt1, Pgrepict1);
   WriteTiffShort(strt2, Pgrepict2);
   WriteTiffShort(strt3, Pgrepict3);
*/
  for (pic_col=0; pic_col<UC; pic_col++)
   for (pic_row=0; pic_row<UR; pic_row++)
   {
    SetGRE(Pgrepic2,pic_col,pic_row,GRE(Pgrepict0,pic_col,pic_row));
    SetGRE(Pgrepic3,pic_col,pic_row,GRE(Pgrepict1,pic_col,pic_row));
    SetGRE(Pgrepic4,pic_col,pic_row,GRE(Pgrepict2,pic_col,pic_row));
    SetGRE(Pgrepic5,pic_col,pic_row,GRE(Pgrepict3,pic_col,pic_row));
   }

// Processing the first binary image
  int_ptr0_0=(int *) calloc(UR*UC, sizeof(int));
  ref_int_ptr0_0=int_ptr0_0;  
 
  for (pic_col=0; pic_col<UC; pic_col++)
   for (pic_row=0; pic_row<UR; pic_row++)
    {
     pixel_value=(int) GRE(Pgrepic2,pic_col,pic_row);
     SetGRE(Pgrepic2,pic_col,pic_row,(Tbrh) 255);
     erosion_c0(Pgrepic2, pic_col, pic_row);
     count= count_ones(5);
     * int_ptr0_0 =count;
     int_ptr0_0++;
     SetGRE(Pgrepic2,pic_col,pic_row, (Tbrh) pixel_value);
    }
   int_ptr0_0=ref_int_ptr0_0; 
    
   int_ptr1_0=(int *) calloc(UR*UC, sizeof(int));
   ref_int_ptr1_0=int_ptr1_0;

   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
     {
      pixel_value=(int) GRE(Pgrepic2,pic_col,pic_row);
      SetGRE(Pgrepic2,pic_col,pic_row,(Tbrh) 255);
      erosion_c1(Pgrepic2, pic_col, pic_row);
      count=count_ones(3);
      * int_ptr1_0 =count;
      int_ptr1_0++;
      SetGRE(Pgrepic2,pic_col,pic_row, (Tbrh) pixel_value);
     }
   int_ptr1_0=ref_int_ptr1_0;

// Processing the second binary image
  int_ptr0_1=(int *) calloc(UR*UC, sizeof(int));
  ref_int_ptr0_1=int_ptr0_1;
 
   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
    {
     pixel_value=(int) GRE(Pgrepic3,pic_col,pic_row);
     SetGRE(Pgrepic3,pic_col,pic_row,(Tbrh) 255);
     erosion_c0(Pgrepic3, pic_col, pic_row);
     count= count_ones(5);
     * int_ptr0_1 =count;
     int_ptr0_1++;
     SetGRE(Pgrepic3,pic_col,pic_row, (Tbrh) pixel_value);
    }
   int_ptr0_1=ref_int_ptr0_1; 
    
   int_ptr1_1=(int *) calloc(UR*UC, sizeof(int));
   ref_int_ptr1_1=int_ptr1_1;
   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
     {
      pixel_value=(int) GRE(Pgrepic3,pic_col,pic_row);
      SetGRE(Pgrepic3,pic_col,pic_row,(Tbrh) 255);
      erosion_c1(Pgrepic3, pic_col, pic_row);
      count=count_ones(3);
      * int_ptr1_1 =count;
      int_ptr1_1++;
      SetGRE(Pgrepic3,pic_col,pic_row, (Tbrh) pixel_value);
     }
   int_ptr1_1=ref_int_ptr1_1;
  
// Processing the third binary image
   int_ptr0_2=(int *) calloc(UR*UC, sizeof(int));
   ref_int_ptr0_2=int_ptr0_2;
 
    for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
    {
     pixel_value=(int) GRE(Pgrepic4,pic_col,pic_row);
     SetGRE(Pgrepic4,pic_col,pic_row,(Tbrh) 255);
     erosion_c0(Pgrepic4, pic_col, pic_row);
     count= count_ones(5);
     * int_ptr0_2 =count;
     int_ptr0_2++;
     SetGRE(Pgrepic4,pic_col,pic_row, (Tbrh) pixel_value);
    }
   int_ptr0_2=ref_int_ptr0_2; 
    
   int_ptr1_2=(int *) calloc(UR*UC, sizeof(int));
   ref_int_ptr1_2=int_ptr1_2;
   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
     {
      pixel_value=(int) GRE(Pgrepic4,pic_col,pic_row);
      SetGRE(Pgrepic4,pic_col,pic_row,(Tbrh) 255);
      erosion_c1(Pgrepic4, pic_col, pic_row);
      count=count_ones(3);
      * int_ptr1_2 =count;
      int_ptr1_2++;
      SetGRE(Pgrepic4,pic_col,pic_row, (Tbrh) pixel_value);
     }
   int_ptr1_2=ref_int_ptr1_2;
  
// Processing the fourth binary image
  int_ptr0_3=(int *) calloc(UR*UC, sizeof(int));
  ref_int_ptr0_3=int_ptr0_3; 
 
   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
    {
     pixel_value=(int) GRE(Pgrepic5,pic_col,pic_row);
     SetGRE(Pgrepic5,pic_col,pic_row,(Tbrh) 255);
     erosion_c0(Pgrepic5, pic_col, pic_row);
     count= count_ones(5);
     * int_ptr0_3 =count;
     int_ptr0_3++;
     SetGRE(Pgrepic5,pic_col,pic_row, (Tbrh) pixel_value);
    }
   int_ptr0_3=ref_int_ptr0_3; 
    
   int_ptr1_3=(int *) calloc(UR*UC, sizeof(int));
   ref_int_ptr1_3=int_ptr1_3;
   for (pic_col=0; pic_col<UC; pic_col++)
    for (pic_row=0; pic_row<UR; pic_row++)
     {
      pixel_value=(int) GRE(Pgrepic5,pic_col,pic_row);
      SetGRE(Pgrepic5,pic_col,pic_row,(Tbrh) 255);
      erosion_c1(Pgrepic5, pic_col, pic_row);
      count=count_ones(3);
      * int_ptr1_3 =count;
      int_ptr1_3++;
      SetGRE(Pgrepic5,pic_col,pic_row, (Tbrh) pixel_value);
     }
   int_ptr1_3=ref_int_ptr1_3;
  
  for (pic_col=0; pic_col<UC; pic_col++)
   for (pic_row=0; pic_row<UR; pic_row++)
   { 
   t=alpha[0]+beta[0][0]*(double(* int_ptr0_0))
   +beta[0][1]*(double(* int_ptr1_0));
    int_ptr0_0++;
    int_ptr1_0++;
    prob_of_one[0] = exp(t);

   t=alpha[1]+beta[1][0]*(double(* int_ptr0_1))
   +beta[1][1]*(double(* int_ptr1_1));
    int_ptr0_1++;
    int_ptr1_1++;
    prob_of_one[1] = exp(t);

   t=alpha[2]+beta[2][0]*(double(* int_ptr0_2))
   +beta[2][1]*(double(* int_ptr1_2));
    int_ptr0_2++;
    int_ptr1_2++;
    prob_of_one[2] = exp(t);

   t=alpha[3]+beta[3][0]*(double(* int_ptr0_3))
   +beta[3][1]*(double(* int_ptr1_3));
    int_ptr0_3++;
    int_ptr1_3++;
    prob_of_one[3] = exp(t);
    
    sum_of_probs=0;
    for (i=0; i<4; i++)
    sum_of_probs+=prob_of_one[i];

    cumulative_prob[0]=prob_of_one[0]/sum_of_probs;
//    printf("\nc_p[0]=%f",cumulative_prob[0]);
    
    for (i=1; i<4; i++)
    {cumulative_prob[i] = cumulative_prob[i-1] + (prob_of_one[i]/sum_of_probs);
//     printf("\nc_p[%d]=%f",i,cumulative_prob[i]);
    } 
     ud0sample=randomfunction();
//     printf("\nud=%f",ud0sample);
     if (double(ud0sample) < cumulative_prob[0])
     SetGRE(Pxpic,pic_col,pic_row,(Tbrh) 0);
     else  if (double(ud0sample) <cumulative_prob[1])
     SetGRE(Pxpic,pic_col,pic_row,(Tbrh) 85);
     else if (double(ud0sample) <cumulative_prob[2])
     SetGRE(Pxpic,pic_col,pic_row,(Tbrh) 170);
     else SetGRE(Pxpic,pic_col,pic_row,(Tbrh) 255);
   }
   
//  fprintf(mesF,"\nSaving the output image");
  WriteTiffShort(str2,Pxpic);

  cfree(ref_int_ptr0_0);
  cfree(ref_int_ptr1_0);
  cfree(ref_int_ptr0_1);
  cfree(ref_int_ptr1_1);
  cfree(ref_int_ptr0_2);
  cfree(ref_int_ptr1_2);
  cfree(ref_int_ptr0_3);
  cfree(ref_int_ptr1_3);
  cfree(Pgrepic1);

  goto XX;
  return 0;
}

int erosion_c0(Tpic * picture, int col, int row)
{
  int sum_row1, sum_col1;
  
  for (i=0; i<5; i++)
   {
    sum_col1 = col - struct_el0[i][0];
    sum_row1 = row + struct_el0[i][1];
    minimum[i]= one_pixel_ero0(picture, sum_col1, sum_row1);
   }
//   printf("\nmin= %d %d %d %d %d",minimum[0],minimum[1],
//   minimum[2],minimum[3],minimum[4]);
//   fprintf(mesF,"\nmin= %d %d %d %d %d",minimum[0],minimum[1],
//  minimum[2],minimum[3],minimum[4]);
   return 0;
}

int erosion_c1(Tpic * picture, int col, int row)
{
  int sum_row1, sum_col1;
  
  for (i=0; i<3; i++)
   {
    sum_col1 = col - struct_el1[i][0];
    sum_row1 = row + struct_el1[i][1];
    minimum[i]= one_pixel_ero1(picture, sum_col1, sum_row1);
   }
//   printf("\nmin= %d %d %d ",minimum[0],minimum[1],
//   minimum[2]);
//   fprintf(mesF,"\nmin= %d %d %d ",minimum[0],minimum[1],
//  minimum[2]);
   return 0;
}

int one_pixel_ero0(Tpic * pict, int pic_col, int pic_row)
{
  int sum_row, sum_col;
  int local_value;
  int i;
  int local_min;

  local_min = 255;

  for (i=0; i<5; i++)
  {
   sum_col = pic_col + struct_el0[i][0];
   sum_row = pic_row - struct_el0[i][1];

   if (sum_col>0) sum_col = sum_col % UC;
   if (sum_col<0) {sum_col +=UC;}
   if (sum_row>0) sum_row = sum_row % UR;
   if (sum_row<0) {sum_row +=UR;}
//   printf("\nsum_col=%d sum_row=%d",sum_col,sum_row);
//   fprintf(mesF,"\nsum_col=%d sum_row=%d",sum_col,sum_row);
   local_value =(int ) GRE(pict,sum_col,sum_row);
//   fprintf(mesF," lf=%d ",local_value);
   if (local_value < local_min) local_min = local_value;
  }
//   fprintf(mesF,"\nlocal_min=%d\n",local_min);
   return local_min;
}

int one_pixel_ero1(Tpic * pict, int pic_col, int pic_row)
{
  int sum_row, sum_col;
  int local_value;
  int i;
  int local_min;

  local_min = 255;

  for (i=0; i<3; i++)
  {
   sum_col = pic_col + struct_el1[i][0];
   sum_row = pic_row - struct_el1[i][1];

   if (sum_col>0) sum_col = sum_col % UC;
   if (sum_col<0) {sum_col +=UC;}
   if (sum_row>0) sum_row = sum_row % UR;
   if (sum_row<0) {sum_row +=UR;}
//   printf("\nsum_col=%d sum_row=%d",sum_col,sum_row);
//   fprintf(mesF,"\nsum_col=%d sum_row=%d",sum_col,sum_row);
   local_value =(int ) GRE(pict,sum_col,sum_row);
//   fprintf(mesF," lf=%d ",local_value);
   if (local_value < local_min) local_min = local_value;
  }
//   fprintf(mesF,"\nlocal_min=%d\n",local_min);
   return local_min;
}

int count_ones(int size_of_el)
{
 int value;
 
 value=0;
 for (i=0; i<size_of_el; i++)
  if (minimum[i]==255) value++;
 return value;
}

float randomfunction()
{
 float temp;
    z1=171*(z1 % 177)-2*(z1/177);
    if (z1<0) z1 +=30269;
    z2=172*(z2 % 176)-35*(z2/176);
    if (z2<0) z2 +=30307;
    z3=170*(z3 %178)-63*(z3/178);
    if (z3<0) z3 +=30323;
    temp=float(z1)/30269.0+ float(z2)/30307.0+ float(z3)/30323.0;
    return (temp- int(temp));
}
