/* * * * * * * * * * * * * * * * * * * * * * * * * * * *
*  Program recgrayf.c                                   *
*  Copyright (C) 1988 by Mariusz Nieniewski            *
*                                                      *
*  Permission is granted to use and copy this package, *
*  but not to sell any part of if without the author's *
*  written permission. This notice must remain in  any *
*  copy or derivative.                                 *
*                                 mnieniew@ippt.gov.pl *
*                                   nieniew&iel.waw.pl *
* * * * * * * * * * * * * * * * * * * * * * * * * * * */ 

/* Pogram recgrayf.c - Sequential Reconstruction
   Created by T. C. Nguyen Apr 13, 1998 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pic.h"
#include "pic_io.h"

extern int UR;
extern int UC;
extern int UR1;
extern int UC1;
extern int UR_reduced;
extern int UC_reduced;

#define zabraklo_pamieci 6
#define Defectsmax  1024


typedef struct tagNode
{
 struct tagNode *next;
 int x,y;
} Node;
Node *start,*end,*tmp;
Node *Insert(int x,int y)
{
 Node *nd=(Node*)malloc(sizeof(Node));
 nd->x=x;nd->y=y;
 nd->next=NULL;
 if(end) end->next=nd;
 printf(" In %d %d ",x,y);
 if(start==NULL)start=nd;//if start==NULL
 return nd;
}
Node *Remove(int *x,int *y)
{
 if(start)
  {
   Node *nd=start->next;
   if(nd==NULL)end=NULL;
   *x=start->x;*y=start->y;
   printf(" Out %d %d",*x,*y);
   free(start);
   return nd;
  }
 else
  return NULL;
}

FILE * seqF;
char NaminpicF1[80],NaminpicF2[80],NamoutpicF[80];
char NamseqF[80];
int UR, UC, UR1, UC1;

int recgrayf(Tpic * picture_1, Tpic * picture_2)
{
  int pic_row, pic_col;
  int i,j,max,v,pic2,inOK=0;
  int i0,iR,j0,jC;
  start=end=NULL;
while(inOK==0)
{
  inOK=1;
  //scan I in raster order
  for (pic_row = 0; pic_row <= UR1; pic_row++)
  for (pic_col = 0; pic_col <= UC1; pic_col++)
  {  //NGplus
    max=pic2=GRE(picture_2,pic_col,pic_row);
    i0=(pic_row==0)?0:-1; iR=0;
    j0=(pic_col==0)?0:-1; jC=(pic_col==UC1)?0:1;
    for(i=i0;i<=iR;i++)
    for(j=j0;j<=jC;j++)
     if(i==-1||j==-1){v=GRE(picture_2,pic_col+j,pic_row+i);if(v>max)max=v;}
   if ((v=GRE(picture_1,pic_col,pic_row))>max)v=max;
   if(pic2!=v){SetGRE(picture_2,pic_col,pic_row, (Tbrh)v);inOK=0;}
  }
  //scan I in anti-raster order
  for (pic_row = UR1; pic_row >= 0; pic_row--)
  for (pic_col = UC1; pic_col >= 0; pic_col--)
  {  //NGminus
    max=pic2=GRE(picture_2,pic_col,pic_row);
    i0=(pic_row==UR1)?0:1; iR=0;
    j0=(pic_col==UC1)?0:1; jC=(pic_col==0)?0:-1;
    for(i=i0;i>=iR;i--)
    for(j=j0;j>=jC;j--)
     if(i==1||j==1)
     {
      if((v=GRE(picture_2,pic_col+j,pic_row+i))>max)max=v;
     }
    if((v=GRE(picture_1,pic_col,pic_row))>max)v=max;
    if(pic2!=v){SetGRE(picture_2,pic_col,pic_row, (Tbrh)v);inOK=0;}
  }
}
  return OK;
} /* END of rec1 */

void main(int argc, char *argv[])
{

  Tpic grepic1, grepic2, xpic;
  Tpic *Pgrepic1 = &grepic1;
  Tpic *Pgrepic2 = &grepic2;
  Tpic *Pxpic    = &xpic;


  char  * str1;
  char  * str2;
  char  * str3;

  InitPic(Pgrepic1);
  InitPic(Pgrepic2);
  InitPic(Pxpic);

  if (argc==1) exit(-1);
  strcpy(NamseqF,argv[1]);
  printf("\n%s",NamseqF);
  if ((seqF = fopen(NamseqF,"r")) == NULL )
   {printf(" - WRONG SEQUENCE"); exit(1); }
  /* Getting the name of the first input image */
  printf("\nType in the name of the first input image: ");
  fscanf(seqF, "%s",NaminpicF1);
  printf("%s",NaminpicF1);
  str1=NaminpicF1;
  ReadTiffShort(Pgrepic1,str1);
  UC=_Zx(Pgrepic1);
  UR=_Zy(Pgrepic1);
  UC1=UC-1;
  UR1=UR-1;
  /* Getting the name of the second input image */
   printf("\nType in the name of the second input image: ");
   fscanf(seqF, "%s",NaminpicF2);
   printf("%s",NaminpicF2);
   str2=NaminpicF2;
   ReadTiffShort(Pgrepic2,str2);
   /* Getting the name of the output image */
   printf("\nType in the name of the output image: ");
   fscanf(seqF, "%s",NamoutpicF);
   printf("%s",NamoutpicF);
   str3=NamoutpicF;
   AllocPic(Pxpic,GREpic,UC,UR);
   recgrayf(Pgrepic1, Pgrepic2);
   printf("\nSaving the output image");
   WriteTiffShort(str3,Pgrepic2);
   FreePic(Pgrepic1);
   FreePic(Pgrepic2);
   FreePic(Pxpic);

}



